package com.yutou.bilibili.mybatis.Bili.mybatis.model;

import java.util.ArrayList;
import java.util.List;

public class BilibiliUpInfoExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public BilibiliUpInfoExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andNameIsNull() {
            addCriterion("`name` is null");
            return (Criteria) this;
        }

        public Criteria andNameIsNotNull() {
            addCriterion("`name` is not null");
            return (Criteria) this;
        }

        public Criteria andNameEqualTo(String value) {
            addCriterion("`name` =", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotEqualTo(String value) {
            addCriterion("`name` <>", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameGreaterThan(String value) {
            addCriterion("`name` >", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameGreaterThanOrEqualTo(String value) {
            addCriterion("`name` >=", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameLessThan(String value) {
            addCriterion("`name` <", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameLessThanOrEqualTo(String value) {
            addCriterion("`name` <=", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameLike(String value) {
            addCriterion("`name` like", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotLike(String value) {
            addCriterion("`name` not like", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameIn(List<String> values) {
            addCriterion("`name` in", values, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotIn(List<String> values) {
            addCriterion("`name` not in", values, "name");
            return (Criteria) this;
        }

        public Criteria andNameBetween(String value1, String value2) {
            addCriterion("`name` between", value1, value2, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotBetween(String value1, String value2) {
            addCriterion("`name` not between", value1, value2, "name");
            return (Criteria) this;
        }

        public Criteria andUrlIsNull() {
            addCriterion("url is null");
            return (Criteria) this;
        }

        public Criteria andUrlIsNotNull() {
            addCriterion("url is not null");
            return (Criteria) this;
        }

        public Criteria andUrlEqualTo(String value) {
            addCriterion("url =", value, "url");
            return (Criteria) this;
        }

        public Criteria andUrlNotEqualTo(String value) {
            addCriterion("url <>", value, "url");
            return (Criteria) this;
        }

        public Criteria andUrlGreaterThan(String value) {
            addCriterion("url >", value, "url");
            return (Criteria) this;
        }

        public Criteria andUrlGreaterThanOrEqualTo(String value) {
            addCriterion("url >=", value, "url");
            return (Criteria) this;
        }

        public Criteria andUrlLessThan(String value) {
            addCriterion("url <", value, "url");
            return (Criteria) this;
        }

        public Criteria andUrlLessThanOrEqualTo(String value) {
            addCriterion("url <=", value, "url");
            return (Criteria) this;
        }

        public Criteria andUrlLike(String value) {
            addCriterion("url like", value, "url");
            return (Criteria) this;
        }

        public Criteria andUrlNotLike(String value) {
            addCriterion("url not like", value, "url");
            return (Criteria) this;
        }

        public Criteria andUrlIn(List<String> values) {
            addCriterion("url in", values, "url");
            return (Criteria) this;
        }

        public Criteria andUrlNotIn(List<String> values) {
            addCriterion("url not in", values, "url");
            return (Criteria) this;
        }

        public Criteria andUrlBetween(String value1, String value2) {
            addCriterion("url between", value1, value2, "url");
            return (Criteria) this;
        }

        public Criteria andUrlNotBetween(String value1, String value2) {
            addCriterion("url not between", value1, value2, "url");
            return (Criteria) this;
        }

        public Criteria andRoomidIsNull() {
            addCriterion("roomid is null");
            return (Criteria) this;
        }

        public Criteria andRoomidIsNotNull() {
            addCriterion("roomid is not null");
            return (Criteria) this;
        }

        public Criteria andRoomidEqualTo(Integer value) {
            addCriterion("roomid =", value, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidNotEqualTo(Integer value) {
            addCriterion("roomid <>", value, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidGreaterThan(Integer value) {
            addCriterion("roomid >", value, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidGreaterThanOrEqualTo(Integer value) {
            addCriterion("roomid >=", value, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidLessThan(Integer value) {
            addCriterion("roomid <", value, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidLessThanOrEqualTo(Integer value) {
            addCriterion("roomid <=", value, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidIn(List<Integer> values) {
            addCriterion("roomid in", values, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidNotIn(List<Integer> values) {
            addCriterion("roomid not in", values, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidBetween(Integer value1, Integer value2) {
            addCriterion("roomid between", value1, value2, "roomid");
            return (Criteria) this;
        }

        public Criteria andRoomidNotBetween(Integer value1, Integer value2) {
            addCriterion("roomid not between", value1, value2, "roomid");
            return (Criteria) this;
        }

        public Criteria andOfflinelisteningIsNull() {
            addCriterion("offlineListening is null");
            return (Criteria) this;
        }

        public Criteria andOfflinelisteningIsNotNull() {
            addCriterion("offlineListening is not null");
            return (Criteria) this;
        }

        public Criteria andOfflinelisteningEqualTo(Integer value) {
            addCriterion("offlineListening =", value, "offlinelistening");
            return (Criteria) this;
        }

        public Criteria andOfflinelisteningNotEqualTo(Integer value) {
            addCriterion("offlineListening <>", value, "offlinelistening");
            return (Criteria) this;
        }

        public Criteria andOfflinelisteningGreaterThan(Integer value) {
            addCriterion("offlineListening >", value, "offlinelistening");
            return (Criteria) this;
        }

        public Criteria andOfflinelisteningGreaterThanOrEqualTo(Integer value) {
            addCriterion("offlineListening >=", value, "offlinelistening");
            return (Criteria) this;
        }

        public Criteria andOfflinelisteningLessThan(Integer value) {
            addCriterion("offlineListening <", value, "offlinelistening");
            return (Criteria) this;
        }

        public Criteria andOfflinelisteningLessThanOrEqualTo(Integer value) {
            addCriterion("offlineListening <=", value, "offlinelistening");
            return (Criteria) this;
        }

        public Criteria andOfflinelisteningIn(List<Integer> values) {
            addCriterion("offlineListening in", values, "offlinelistening");
            return (Criteria) this;
        }

        public Criteria andOfflinelisteningNotIn(List<Integer> values) {
            addCriterion("offlineListening not in", values, "offlinelistening");
            return (Criteria) this;
        }

        public Criteria andOfflinelisteningBetween(Integer value1, Integer value2) {
            addCriterion("offlineListening between", value1, value2, "offlinelistening");
            return (Criteria) this;
        }

        public Criteria andOfflinelisteningNotBetween(Integer value1, Integer value2) {
            addCriterion("offlineListening not between", value1, value2, "offlinelistening");
            return (Criteria) this;
        }

        public Criteria andSavedanmuIsNull() {
            addCriterion("saveDanmu is null");
            return (Criteria) this;
        }

        public Criteria andSavedanmuIsNotNull() {
            addCriterion("saveDanmu is not null");
            return (Criteria) this;
        }

        public Criteria andSavedanmuEqualTo(Integer value) {
            addCriterion("saveDanmu =", value, "savedanmu");
            return (Criteria) this;
        }

        public Criteria andSavedanmuNotEqualTo(Integer value) {
            addCriterion("saveDanmu <>", value, "savedanmu");
            return (Criteria) this;
        }

        public Criteria andSavedanmuGreaterThan(Integer value) {
            addCriterion("saveDanmu >", value, "savedanmu");
            return (Criteria) this;
        }

        public Criteria andSavedanmuGreaterThanOrEqualTo(Integer value) {
            addCriterion("saveDanmu >=", value, "savedanmu");
            return (Criteria) this;
        }

        public Criteria andSavedanmuLessThan(Integer value) {
            addCriterion("saveDanmu <", value, "savedanmu");
            return (Criteria) this;
        }

        public Criteria andSavedanmuLessThanOrEqualTo(Integer value) {
            addCriterion("saveDanmu <=", value, "savedanmu");
            return (Criteria) this;
        }

        public Criteria andSavedanmuIn(List<Integer> values) {
            addCriterion("saveDanmu in", values, "savedanmu");
            return (Criteria) this;
        }

        public Criteria andSavedanmuNotIn(List<Integer> values) {
            addCriterion("saveDanmu not in", values, "savedanmu");
            return (Criteria) this;
        }

        public Criteria andSavedanmuBetween(Integer value1, Integer value2) {
            addCriterion("saveDanmu between", value1, value2, "savedanmu");
            return (Criteria) this;
        }

        public Criteria andSavedanmuNotBetween(Integer value1, Integer value2) {
            addCriterion("saveDanmu not between", value1, value2, "savedanmu");
            return (Criteria) this;
        }

        public Criteria andEnableIsNull() {
            addCriterion("`enable` is null");
            return (Criteria) this;
        }

        public Criteria andEnableIsNotNull() {
            addCriterion("`enable` is not null");
            return (Criteria) this;
        }

        public Criteria andEnableEqualTo(Integer value) {
            addCriterion("`enable` =", value, "enable");
            return (Criteria) this;
        }

        public Criteria andEnableNotEqualTo(Integer value) {
            addCriterion("`enable` <>", value, "enable");
            return (Criteria) this;
        }

        public Criteria andEnableGreaterThan(Integer value) {
            addCriterion("`enable` >", value, "enable");
            return (Criteria) this;
        }

        public Criteria andEnableGreaterThanOrEqualTo(Integer value) {
            addCriterion("`enable` >=", value, "enable");
            return (Criteria) this;
        }

        public Criteria andEnableLessThan(Integer value) {
            addCriterion("`enable` <", value, "enable");
            return (Criteria) this;
        }

        public Criteria andEnableLessThanOrEqualTo(Integer value) {
            addCriterion("`enable` <=", value, "enable");
            return (Criteria) this;
        }

        public Criteria andEnableIn(List<Integer> values) {
            addCriterion("`enable` in", values, "enable");
            return (Criteria) this;
        }

        public Criteria andEnableNotIn(List<Integer> values) {
            addCriterion("`enable` not in", values, "enable");
            return (Criteria) this;
        }

        public Criteria andEnableBetween(Integer value1, Integer value2) {
            addCriterion("`enable` between", value1, value2, "enable");
            return (Criteria) this;
        }

        public Criteria andEnableNotBetween(Integer value1, Integer value2) {
            addCriterion("`enable` not between", value1, value2, "enable");
            return (Criteria) this;
        }

        public Criteria andLiveIsNull() {
            addCriterion("live is null");
            return (Criteria) this;
        }

        public Criteria andLiveIsNotNull() {
            addCriterion("live is not null");
            return (Criteria) this;
        }

        public Criteria andLiveEqualTo(Integer value) {
            addCriterion("live =", value, "live");
            return (Criteria) this;
        }

        public Criteria andLiveNotEqualTo(Integer value) {
            addCriterion("live <>", value, "live");
            return (Criteria) this;
        }

        public Criteria andLiveGreaterThan(Integer value) {
            addCriterion("live >", value, "live");
            return (Criteria) this;
        }

        public Criteria andLiveGreaterThanOrEqualTo(Integer value) {
            addCriterion("live >=", value, "live");
            return (Criteria) this;
        }

        public Criteria andLiveLessThan(Integer value) {
            addCriterion("live <", value, "live");
            return (Criteria) this;
        }

        public Criteria andLiveLessThanOrEqualTo(Integer value) {
            addCriterion("live <=", value, "live");
            return (Criteria) this;
        }

        public Criteria andLiveIn(List<Integer> values) {
            addCriterion("live in", values, "live");
            return (Criteria) this;
        }

        public Criteria andLiveNotIn(List<Integer> values) {
            addCriterion("live not in", values, "live");
            return (Criteria) this;
        }

        public Criteria andLiveBetween(Integer value1, Integer value2) {
            addCriterion("live between", value1, value2, "live");
            return (Criteria) this;
        }

        public Criteria andLiveNotBetween(Integer value1, Integer value2) {
            addCriterion("live not between", value1, value2, "live");
            return (Criteria) this;
        }

        public Criteria andSaveliveIsNull() {
            addCriterion("saveLive is null");
            return (Criteria) this;
        }

        public Criteria andSaveliveIsNotNull() {
            addCriterion("saveLive is not null");
            return (Criteria) this;
        }

        public Criteria andSaveliveEqualTo(Integer value) {
            addCriterion("saveLive =", value, "savelive");
            return (Criteria) this;
        }

        public Criteria andSaveliveNotEqualTo(Integer value) {
            addCriterion("saveLive <>", value, "savelive");
            return (Criteria) this;
        }

        public Criteria andSaveliveGreaterThan(Integer value) {
            addCriterion("saveLive >", value, "savelive");
            return (Criteria) this;
        }

        public Criteria andSaveliveGreaterThanOrEqualTo(Integer value) {
            addCriterion("saveLive >=", value, "savelive");
            return (Criteria) this;
        }

        public Criteria andSaveliveLessThan(Integer value) {
            addCriterion("saveLive <", value, "savelive");
            return (Criteria) this;
        }

        public Criteria andSaveliveLessThanOrEqualTo(Integer value) {
            addCriterion("saveLive <=", value, "savelive");
            return (Criteria) this;
        }

        public Criteria andSaveliveIn(List<Integer> values) {
            addCriterion("saveLive in", values, "savelive");
            return (Criteria) this;
        }

        public Criteria andSaveliveNotIn(List<Integer> values) {
            addCriterion("saveLive not in", values, "savelive");
            return (Criteria) this;
        }

        public Criteria andSaveliveBetween(Integer value1, Integer value2) {
            addCriterion("saveLive between", value1, value2, "savelive");
            return (Criteria) this;
        }

        public Criteria andSaveliveNotBetween(Integer value1, Integer value2) {
            addCriterion("saveLive not between", value1, value2, "savelive");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {
        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}